<?php

/* This file is part of Jeedom.
*
* Jeedom is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Jeedom is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Jeedom. If not, see <http://www.gnu.org/licenses/>.
*/
header('Access-Control-Allow-Origin: *');
header("Access-Control-Allow-Methods: POST, GET");
header("Access-Control-Allow-Headers: Content-Type");
require_once __DIR__ . "/../php/core.inc.php";
if (user::isBan()) {
	header("Status: 404 Not Found");
	header('HTTP/1.0 404 Not Found');
	$_SERVER['REDIRECT_STATUS'] = 404;
	echo "<h1>404 Not Found</h1>";
	echo "The page that you have requested could not be found.";
	die();
}
/** @var user|null $_USER_GLOBAL */
global $_USER_GLOBAL;
$_USER_GLOBAL = null;
/** @var bool $_RESTRICTED */
global $_RESTRICTED;
$_RESTRICTED = false;
if (init('type') != '') {
	try {
		if (init('type') == 'ask') {
			if (trim(init('token')) == '' || strlen(init('token')) < 64) {
				throw new Exception(__('Commande inconnue ou Token invalide', __FILE__));
			}
			$cmd = cmd::byId(init('cmd_id'));
			if (!is_object($cmd)) {
				throw new Exception(__('Commande inconnue ou Token invalide', __FILE__));
			}
			if (trim($cmd->getCache('ask::token', config::genKey())) != init('token')) {
				throw new Exception(__('Commande inconnue ou Token invalide', __FILE__));
			}
			if (!$cmd->askResponse(init('response'))) {
				throw new Exception(__('Erreur response ask, temps écoulé ou réponse invalide', __FILE__));
			}
			die();
		}
		$plugin = init('plugin', 'core');
		if (in_array($plugin, array('apitts', 'apipro', 'apimarket'))) {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__));
		}
		if (!jeedom::apiAccess(init('apikey', init('api')), $plugin)) {
			user::failedLogin();
			sleep(5);
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action, IP :', __FILE__) . ' ' . getClientIp());
		}
		$type = init('type');
		log::add('api', 'debug', __('Demande sur l\'api http venant de :', __FILE__) . ' ' . getClientIp() . ' => ' . json_encode($_GET));

		if ($type == 'event' && class_exists($plugin) && method_exists($plugin, 'event')) {
			log::add('api', 'info', __('Appels de', __FILE__) . ' ' . secureXSS($plugin) . '::event()');
			$plugin::event();
			die();
		}
		if ($_RESTRICTED) {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__));
		}
		if ($type == 'cmd') {
			if (is_json(init('id'))) {
				$ids = json_decode(init('id'), true);
				$result = array();
				foreach ($ids as $id) {
					$cmd = cmd::byId($id);
					if (!is_object($cmd)) {
						throw new Exception(__('Aucune commande correspondant à l\'ID :', __FILE__) . ' ' . secureXSS($id));
					}
					if ($plugin != 'core' && $plugin != $cmd->getEqType() && $_RESTRICTED) {
						throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action, IP :', __FILE__) . ' ' . getClientIp());
					}
					if ($_USER_GLOBAL != null && !$cmd->hasRight($_USER_GLOBAL)) {
						continue;
					}
					$result[$id] = $cmd->execCmd($_REQUEST);
				}
				echo json_encode($result);
				die();
			} else {
				$cmd = cmd::byId(init('id'));
				if (!is_object($cmd)) {
					throw new Exception(__('Aucune commande correspondant à l\'ID :', __FILE__) . ' ' . secureXSS(init('id')));
				}
				if ($plugin != 'core' && $plugin != $cmd->getEqType() && $_RESTRICTED) {
					throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action, IP :', __FILE__) . ' ' . getClientIp());
				}
				if ($_USER_GLOBAL != null && !$cmd->hasRight($_USER_GLOBAL)) {
					throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action, IP :', __FILE__) . ' ' . getClientIp());
				}
				if ($cmd->getType() == 'info' && init('value') != '') {
					$cmd->event(init('value'));
				}
				log::add('api', 'debug', __('Exécution de :', __FILE__) . ' ' . $cmd->getHumanName());
				echo $cmd->execCmd($_REQUEST);
				die();
			}
		}
		if ($type == 'interact') {
			$query = init('query');
			if (init('utf8', 0) == 1) {
				$query = mb_convert_encoding($query, 'UTF-8', 'ISO-8859-1');
			}
			$param = array();
			if (init('emptyReply') != '') {
				$param['emptyReply'] = init('emptyReply');
			}
			if (init('profile') != '') {
				$param['profile'] = init('profile');
			}
			if (init('reply_cmd') != '') {
				$reply_cmd = cmd::byId(init('reply_cmd'));
				if (is_object($reply_cmd)) {
					$param['reply_cmd'] = $reply_cmd;
					$param['force_reply_cmd'] = 1;
				}
			}
			$reply = interactQuery::tryToReply($query, $param);
			echo $reply['reply'];
			die();
		}
		if ($type == 'scenario') {
			log::add('api', 'debug', __('Demande API pour les scénarios', __FILE__));
			if (!init('id')) {
				header('Content-Type: application/json');
				echo json_encode(utils::o2a(scenario::all()), JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE, 1024);
				die();
			}
			$scenario = scenario::byId(init('id'));
			if (!is_object($scenario)) {
				throw new Exception(__('Aucun scénario correspondant à l\'ID :', __FILE__) . ' ' . secureXSS(init('id')));
			}
			if ($_USER_GLOBAL != null && !$scenario->hasRight('x', $_USER_GLOBAL)) {
				throw new Exception(__('Vous n\'avez pas le droit de faire une action sur ce scénario', __FILE__));
			}
			$return = 'ok';
			switch (init('action')) {
				case 'start':
					log::add('api', 'debug', __('Démarrage scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$tags = array();
					foreach ($_REQUEST as $key => $value) {
						$tags['#' . $key . '#'] = $value;
					}
					if (init('tags') != '' && !is_array(init('tags'))) {
						$_tags = array();
						$args = arg2array(init('tags'));
						foreach ($args as $key => $value) {
							$_tags['#' . trim(trim($key), '#') . '#'] = scenarioExpression::setTags(trim($value), $scenario);
						}
						$scenario->setTags($_tags);
					} else if (is_array(init('tags'))) {
						$scenario->setTags(init('tags'));
					}
					$scenario_return = $scenario->launch('api', __('Exécution provoquée par un appel API', __FILE__) . ' ');
					if (is_string($scenario_return)) {
						$return = $scenario_return;
					}
					break;
				case 'stop':
					log::add('api', 'debug', __('Arrêt scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$scenario->stop();
					break;
				case 'deactivate':
					log::add('api', 'debug', __('Désactivation scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$scenario->setIsActive(0);
					$scenario->save();
					break;
				case 'disable':
					log::add('api', 'debug', __('Désactivation scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$scenario->setIsActive(0);
					$scenario->save();
					break;
				case 'activate':
					log::add('api', 'debug', __('Activation scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$scenario->setIsActive(1);
					$scenario->save();
					break;
				case 'enable':
					log::add('api', 'debug', __('Activation scénario de :', __FILE__) . ' ' . $scenario->getHumanName());
					$scenario->setIsActive(1);
					$scenario->save();
					break;
				default:
					throw new Exception(__('Action non trouvée ou invalide [start,stop,deactivate,activate]', __FILE__));
			}
			echo $return;
			die();
		}
		if ($type == 'message') {
			log::add('api', 'debug', __('Demande API pour ajouter un message', __FILE__));
			message::add(init('category'), init('message'));
			die();
		}
		if ($type == 'object') {
			log::add('api', 'debug', __('Demande API pour les objets', __FILE__));
			header('Content-Type: application/json');
			echo json_encode(utils::o2a(jeeObject::all()), JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE, 1024);
			die();
		}
		if ($type == 'eqLogic') {
			log::add('api', 'debug', __('Demande API pour les équipements', __FILE__));
			header('Content-Type: application/json');
			echo json_encode(utils::o2a(eqLogic::byObjectId(init('object_id'))), JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE, 1024);
			die();
		}
		if ($type == 'command') {
			log::add('api', 'debug', __('Demande API pour les commandes', __FILE__));
			header('Content-Type: application/json');
			echo json_encode(utils::o2a(cmd::byEqLogicId(init('eqLogic_id'))), JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE, 1024);
			die();
		}
		if ($type == 'fullData') {
			log::add('api', 'debug', __('Demande API pour les commandes', __FILE__));
			header('Content-Type: application/json');
			echo json_encode(jeeObject::fullData(), JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE, 1024);
			die();
		}
		if ($type == 'variable') {
			log::add('api', 'debug', __('Demande API pour les variables', __FILE__));
			if (init('value') == '') {
				$dataStore = dataStore::byTypeLinkIdKey('scenario', -1, trim(init('name')));
				if (is_object($dataStore)) {
					echo $dataStore->getValue();
				}
			} else {
				$dataStore = new dataStore();
				$dataStore->setKey(trim(init('name')));
				$dataStore->setValue(init('value'));
				$dataStore->setType('scenario');
				$dataStore->setLink_id(-1);
				$dataStore->save();
			}
			die();
		}
	} catch (Exception $e) {
		echo $e->getMessage();
		log::add('jeeEvent', 'error', $e->getMessage());
	}
	die();
}
try {
	if (!headers_sent()) {
		header('Content-Type: application/json');
	}
	$IP = getClientIp();
	$request = init('request');
	if ($request == '') {
		$request = file_get_contents("php://input");
	}
	log::add('api', 'info', secureXSS($request) . ' - IP :' . $IP);

	$jsonrpc = new jsonrpc($request);

	if ($jsonrpc->getJsonrpc() != '2.0') {
		user::failedLogin();
		throw new Exception(__('Requête invalide. Version JSON-RPC invalide :', __FILE__) . ' ' . $jsonrpc->getJsonrpc(), -32001);
	}

	$params = $jsonrpc->getParams();

	if (!isset($params['plugin']) || $params['plugin'] == '') {
		$params['plugin'] = 'core';
	}
	if (in_array($params['plugin'], array('apitts', 'apipro', 'apimarket'))) {
		throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__), -32001);
	}

	if (!jeedom::apiModeResult(config::byKey('api::' . $params['plugin'] . '::mode', 'core', 'enable'))) {
		throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__), -32001);
	}

	if ($params['plugin'] == 'core') {
		if ($jsonrpc->getMethod() == 'user::useTwoFactorAuthentification') {
			if (network::getUserLocation() == 'internal') {
				$jsonrpc->makeSuccess(0);
			}
			$user = user::byLogin($params['login']);
			if (!is_object($user)) {
				$jsonrpc->makeSuccess(0);
			}
			$jsonrpc->makeSuccess($user->getOptions('twoFactorAuthentification', 0));
		}

		if ($jsonrpc->getMethod() == 'user::getHash') {
			if (!isset($params['login']) || !isset($params['password']) || $params['login'] == '' || $params['password'] == '') {
				user::failedLogin();
				sleep(5);
				throw new Exception(__('L\'identifiant ou le mot de passe ne peuvent pas être vide', __FILE__), -32001);
			}
			$user = user::connect($params['login'], $params['password']);
			if (!is_object($user) || $user->getEnable() != 1) {
				user::failedLogin();
				sleep(5);
				throw new Exception(__('Echec lors de l\'authentification', __FILE__), -32001);
			}
			if (network::getUserLocation() != 'internal' && $user->getOptions('twoFactorAuthentification', 0) == 1 && $user->getOptions('twoFactorAuthentificationSecret') != '') {
				if (!isset($params['twoFactorCode']) || trim($params['twoFactorCode']) == '' || !$user->validateTwoFactorCode($params['twoFactorCode'])) {
					user::failedLogin();
					sleep(5);
					throw new Exception(__('Echec lors de l\'authentification', __FILE__), -32001);
				}
			}
			$jsonrpc->makeSuccess($user->getHash());
		}
	}

	if ($jsonrpc->getMethod() == 'ping') {
		$jsonrpc->makeSuccess('pong');
	}

	if (!isset($params['apikey']) && !isset($params['api'])) {
		throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__), -32001);
	}
	$apikey = isset($params['apikey']) ? $params['apikey'] : $params['api'];

	if (!jeedom::apiAccess($apikey, $params['plugin']) && !jeedom::apiAccess($apikey, 'core')) {
		throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__), -32002);
	}

	if ($params['plugin'] != 'core') {
		try {
			include_file('core', $params['plugin'], 'api', $params['plugin']);
		} catch (\Exception $e) {
			if ($e->getCode() != 35486) {
				throw $e;
			}
		}
	}

	if ($_RESTRICTED) {
		throw new Exception(__('Aucune méthode correspondante :', __FILE__) . ' ' . $jsonrpc->getMethod(), -32500);
	}

	/*             * ************************config*************************** */
	if ($jsonrpc->getMethod() == 'config::byKey') {
		unautorizedInDemo();
		if (!isset($params['default'])) {
			$params['default'] = '';
		}
		if (!isset($params['plugin'])) {
			$params['plugin'] = 'core';
		}
		$jsonrpc->makeSuccess(config::byKey($params['key'], $params['plugin'], $params['default']));
	}

	if ($jsonrpc->getMethod() == 'config::save') {
		unautorizedInDemo();
		if (!isset($params['plugin'])) {
			$params['plugin'] = 'core';
		}
		$jsonrpc->makeSuccess(config::save($params['key'], $params['value'], $params['plugin']));
	}

	/*             * ***********************Version********************************* */
	if ($jsonrpc->getMethod() == 'version') {
		$jsonrpc->makeSuccess(jeedom::version());
	}

	/*             * ***********************isOk********************************* */
	if ($jsonrpc->getMethod() == 'jeedom::isOk') {
		$jsonrpc->makeSuccess(jeedom::isOK());
	}

	if ($jsonrpc->getMethod() == 'jeedom::halt') {
		unautorizedInDemo();
		if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		jeedom::haltSystem();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'jeedom::reboot') {
		unautorizedInDemo();
		if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		jeedom::rebootSystem();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'jeedom::update') {
		unautorizedInDemo();
		if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		jeedom::update($params['options'], 0);
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'jeedom::backup') {
		unautorizedInDemo();
		if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		jeedom::backup(true);
		$jsonrpc->makeSuccess('ok');
	}

	/*             * ***********************Datetime********************************* */
	if ($jsonrpc->getMethod() == 'datetime') {
		$jsonrpc->makeSuccess(getmicrotime());
	}

	/*             * ***********************changes********************************* */
	if ($jsonrpc->getMethod() == 'event::changes') {
		$longPolling = null;
		if (isset($params['longPolling'])) {
			$longPolling = $params['longPolling'];
		}
		$filter = null;
		if (isset($params['filter'])) {
			$filter = $params['filter'];
		}
		$jsonrpc->makeSuccess(event::changes($params['datetime'], $longPolling, $filter));
	}

	/*             * ************************Plugin*************************** */
	if ($jsonrpc->getMethod() == 'plugin::listPlugin') {
		$activateOnly = (isset($params['activateOnly']) && $params['activateOnly'] == 1) ? true : false;
		$orderByCaterogy = (isset($params['orderByCaterogy']) && $params['orderByCaterogy'] == 1) ? true : false;
		$jsonrpc->makeSuccess(utils::o2a(plugin::listPlugin($activateOnly, $orderByCaterogy)));
	}

	/*             * ************************Object*************************** */
	if ($jsonrpc->getMethod() == 'jeeObject::all' || $jsonrpc->getMethod() == 'object::all') {
		$jsonrpc->makeSuccess(utils::o2a(jeeObject::all()));
	}

	if ($jsonrpc->getMethod() == 'jeeObject::byId' || $jsonrpc->getMethod() == 'object::byId') {
		$object = jeeObject::byId($params['id']);
		if (!is_object($object)) {
			throw new Exception(__('Objet introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32601);
		}
		$jsonrpc->makeSuccess(utils::o2a($object));
	}

	if ($jsonrpc->getMethod() == 'jeeObject::full' || $jsonrpc->getMethod() == 'object::full') {
		$jsonrpc->makeSuccess(jeeObject::fullData(array(), $_USER_GLOBAL));
	}

	if ($jsonrpc->getMethod() == 'jeeObject::fullById' || $jsonrpc->getMethod() == 'object::fullById') {
		$object = jeeObject::byId($params['id']);
		if (!is_object($object)) {
			throw new Exception(__('Objet introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32601);
		}
		$return = utils::o2a($object);
		$return['eqLogics'] = array();
		foreach ($object->getEqLogic() as $eqLogic) {
			if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$eqLogic_return = utils::o2a($eqLogic);
			$eqLogic_return['cmds'] = array();
			foreach ($eqLogic->getCmd() as $cmd) {
				$eqLogic_return['cmds'][] = $cmd->exportApi();
			}
			$return['eqLogics'][] = $eqLogic_return;
		}
		$jsonrpc->makeSuccess($return);
	}

	if ($jsonrpc->getMethod() == 'jeeObject::save' || $jsonrpc->getMethod() == 'object::save') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		if (isset($params['id'])) {
			$object = jeeObject::byId($params['id']);
		}
		if (!is_object($object)) {
			$object = new jeeObject();
		}
		utils::a2o($object, jeedom::fromHumanReadable($params));
		$object->save();
		$jsonrpc->makeSuccess(utils::o2a($object));
	}

	/*             * ************************Summary*************************** */

	if ($jsonrpc->getMethod() == 'summary::global') {
		if (isset($params['key'])) {
			$jsonrpc->makeSuccess(jeeObject::getGlobalSummary($params['key']));
		}
		/** @var array $def */
		$def = config::byKey('object:summary');
		foreach ($def as $key => &$value) {
			$value['value'] = jeeObject::getGlobalSummary($key);
		}
		$jsonrpc->makeSuccess($def);
	}

	if ($jsonrpc->getMethod() == 'summary::byId') {
		$object = jeeObject::byId($params['id']);
		if (!is_object($object)) {
			throw new Exception(__('Objet introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32601);
		}
		if (!isset($params['key'])) {
			$params['key'] = '';
		}
		if (!isset($params['raw'])) {
			$params['raw'] = false;
		}
		$jsonrpc->makeSuccess($object->getSummary($params['key'], $params['raw']));
	}

	/*             * ************************Timeline*************************** */

	if ($jsonrpc->getMethod() == 'timeline::all') {
		$jsonrpc->makeSuccess(utils::o2a(timeline::all()));
	}

	if ($jsonrpc->getMethod() == 'timeline::listFolder') {
		$jsonrpc->makeSuccess(timeline::listFolder());
	}

	if ($jsonrpc->getMethod() == 'timeline::byFolder') {
		$jsonrpc->makeSuccess(utils::o2a(timeline::byFolder($params['folder'])));
	}

	/*             * ************************datastore*************************** */

	if ($jsonrpc->getMethod() == 'datastore::byTypeLinkIdKey') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a(dataStore::byTypeLinkIdKey($params['type'], $params['linkId'], $params['key'])));
	}

	if ($jsonrpc->getMethod() == 'datastore::save') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		$dataStore = new dataStore();
		$dataStore->setType($params['type']);
		$dataStore->setKey($params['key']);
		$dataStore->setValue($params['value']);
		$dataStore->setLink_id($params['linkId']);
		$dataStore->save();
		$jsonrpc->makeSuccess('ok');
	}

	/*             * ************************Equipement*************************** */
	if ($jsonrpc->getMethod() == 'eqLogic::all') {
		$return = array();
		foreach (eqLogic::all() as $eqLogic) {
			if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$return[] = $eqLogic;
		}
		$jsonrpc->makeSuccess(utils::o2a($return));
	}

	if ($jsonrpc->getMethod() == 'eqLogic::byType') {
		$return = array();
		foreach (eqLogic::byType($params['type']) as $eqLogic) {
			if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$return[] = $eqLogic;
		}
		$jsonrpc->makeSuccess(utils::o2a($return));
	}

	if ($jsonrpc->getMethod() == 'eqLogic::byObjectId') {
		$return = array();
		foreach (eqLogic::byObjectId($params['object_id']) as $eqLogic) {
			if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$return[] = $eqLogic;
		}
		$jsonrpc->makeSuccess(utils::o2a($return));
	}

	if ($jsonrpc->getMethod() == 'eqLogic::byId') {
		$eqLogic = eqLogic::byId($params['id']);
		if (!is_object($eqLogic)) {
			throw new Exception(__('EqLogic introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32602);
		}
		if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		$jsonrpc->makeSuccess(utils::o2a($eqLogic));
	}

	if ($jsonrpc->getMethod() == 'eqLogic::fullById') {
		$eqLogic = eqLogic::byId($params['id']);
		if (!is_object($eqLogic)) {
			throw new Exception(__('EqLogic introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32602);
		}
		if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		$return = utils::o2a($eqLogic);
		$return['cmds'] = array();
		foreach ($eqLogic->getCmd() as $cmd) {
			$return['cmds'][] = $cmd->exportApi();
		}
		$jsonrpc->makeSuccess($return);
	}

	if ($jsonrpc->getMethod() == 'eqLogic::save') {
		unautorizedInDemo();
		$typeEqLogic = $params['eqType_name'];
		$typeCmd = $typeEqLogic . 'Cmd';
		if ($typeEqLogic == '' || !class_exists($typeEqLogic) || !class_exists($typeCmd)) {
			throw new Exception(__('Type incorrect (classe commande inexistante)', __FILE__) . secureXSS($typeCmd));
		}
		$eqLogic = null;
		if (isset($params['id'])) {
			$eqLogic = $typeEqLogic::byId($params['id']);
		}
		if (!is_object($eqLogic)) {
			$eqLogic = new $typeEqLogic();
			$eqLogic->setEqType_name($params['eqType_name']);
		}
		if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
			throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__) . ' ' . $jsonrpc->getMethod(), -32001);
		}
		utils::a2o($eqLogic, jeedom::fromHumanReadable($params));
		$eqLogic->save();
		$dbList = $typeCmd::byEqLogicId($eqLogic->getId());
		$eqLogic->save();
		$enableList = array();
		if (isset($params['cmd'])) {
			$cmd_order = 0;
			foreach ($params['cmd'] as $cmd_info) {
				$cmd = null;
				if (isset($cmd_info['id'])) {
					$cmd = $typeCmd::byId($cmd_info['id']);
				}
				if (!is_object($cmd)) {
					$cmd = new $typeCmd();
				}
				$cmd->setEqLogic_id($eqLogic->getId());
				$cmd->setOrder($cmd_order);
				utils::a2o($cmd, jeedom::fromHumanReadable($cmd_info));
				$cmd->save();
				$cmd_order++;
				$enableList[$cmd->getId()] = true;
			}
			foreach ($dbList as $dbObject) {
				if (!isset($enableList[$dbObject->getId()]) && !$dbObject->dontRemoveCmd()) {
					$dbObject->remove();
				}
			}
		}
		$jsonrpc->makeSuccess(utils::o2a($eqLogic));
	}

	if ($jsonrpc->getMethod() == 'eqLogic::byTypeAndId') {
		$return = array();
		foreach ($params['eqType'] as $eqType) {
			$info_eqLogics = array();
			foreach (eqLogic::byType($eqType) as $eqLogic) {
				if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
					continue;
				}
				$info_eqLogic = utils::o2a($eqLogic);
				foreach ($eqLogic->getCmd() as $cmd) {
					$info_eqLogic['cmds'][] = $cmd->exportApi();
				}
				$info_eqLogics[] = $info_eqLogic;
			}
			$return[$eqType] = $info_eqLogics;
		}

		foreach ($params['id'] as $id) {
			$eqLogic = eqLogic::byId($id);
			if (is_object($_USER_GLOBAL) && !$eqLogic->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$info_eqLogic = utils::o2a($eqLogic);
			foreach ($eqLogic->getCmd() as $cmd) {
				$info_eqLogic['cmds'][] = $cmd->exportApi();
			}
			$return[$id] = $info_eqLogic;
		}
		$jsonrpc->makeSuccess($return);
	}

	/*             * ************************Commande*************************** */
	if ($jsonrpc->getMethod() == 'cmd::all') {
		$return = array();
		foreach (cmd::all() as $cmd) {
			if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
				continue;
			}
			$return[] = $cmd->exportApi();
		}
		$jsonrpc->makeSuccess($return);
	}

	if ($jsonrpc->getMethod() == 'cmd::byEqLogicId') {
		$return = array();
		foreach (cmd::byEqLogicId($params['eqLogic_id']) as $cmd) {
			if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
				continue;
			}
			$return[] = $cmd->exportApi();
		}
		$jsonrpc->makeSuccess($return);
	}

	if ($jsonrpc->getMethod() == 'cmd::byId') {
		$cmd = cmd::byId($params['id']);
		if (!is_object($cmd)) {
			throw new Exception(__('Cmd introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32701);
		}
		if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur cette commande', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess($cmd->exportApi());
	}

	if ($jsonrpc->getMethod() == 'cmd::execCmd') {
		$return = array();
		if (is_array($params['id'])) {
			foreach ($params['id'] as $id) {
				$cmd = cmd::byId($id);
				if (!is_object($cmd)) {
					throw new Exception(__('Commande introuvable :', __FILE__) . ' ' . secureXSS($id), -32702);
				}
				if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
					continue;
				}
				$eqLogic = $cmd->getEqLogic();
				if (!isset($params['codeAccess'])) {
					$params['codeAccess'] = '';
				}
				if (!$cmd->checkAccessCode($params['codeAccess'])) {
					throw new Exception(__('Cette action nécessite un code d\'accès', __FILE__), -32005);
				}
				if ($cmd->getType() == 'action' && $cmd->getConfiguration('actionConfirm') == 1 && $params['confirmAction'] != 1) {
					throw new Exception(__('Cette action nécessite une confirmation', __FILE__), -32006);
				}
				if ($cmd->getType() == 'info') {
					$return[$id] = array('value' => $cmd->execCmd($params['options']), 'collectDate' => $cmd->getCollectDate());
				} else {
					$cmd->execCmd($params['options']);
				}
			}
		} else {
			$cmd = cmd::byId($params['id']);
			if (!is_object($cmd)) {
				throw new Exception(__('Commande introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32702);
			}
			if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
				throw new Exception(__('Vous n\'êtes pas autorisé à faire cette action', __FILE__));
			}
			if (!isset($params['codeAccess'])) {
				$params['codeAccess'] = '';
			}
			if (!$cmd->checkAccessCode($params['codeAccess'])) {
				throw new Exception(__('Cette action nécessite un code d\'accès', __FILE__), -32005);
			}
			if ($cmd->getType() == 'action' && $cmd->getConfiguration('actionConfirm') == 1 && $params['confirmAction'] != 1) {
				throw new Exception(__('Cette action nécessite une confirmation', __FILE__), -32006);
			}
			if ($cmd->getType() == 'info') {
				$return = array('value' => $cmd->execCmd($params['options']), 'collectDate' => $cmd->getCollectDate());
			} else {
				$cmd->execCmd($params['options']);
			}
		}
		$jsonrpc->makeSuccess($return);
	}

	if ($jsonrpc->getMethod() == 'cmd::getStatistique') {
		$cmd = cmd::byId($params['id']);
		if (!is_object($cmd)) {
			throw new Exception('Commande introuvable : ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur cette commande', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess($cmd->getStatistique($params['startTime'], $params['endTime']));
	}

	if ($jsonrpc->getMethod() == 'cmd::getTendance') {
		$cmd = cmd::byId($params['id']);
		if (!is_object($cmd)) {
			throw new Exception('Commande introuvable : ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur cette commande', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess($cmd->getTendance($params['startTime'], $params['endTime']));
	}

	if ($jsonrpc->getMethod() == 'cmd::getHistory') {
		$cmd = cmd::byId($params['id']);
		if (!is_object($cmd)) {
			throw new Exception('Commande introuvable : ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur cette commande', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a($cmd->getHistory($params['startTime'], $params['endTime'])));
	}

	if ($jsonrpc->getMethod() == 'cmd::save') {
		unautorizedInDemo();
		if (isset($params['id'])) {
			$cmd = cmd::byId($params['id']);
			if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
				throw new Exception(__('Vous n\'êtes pas autorisé à faire cette action', __FILE__));
			}
		} else {
			$typeEqLogic = $params['eqType_name'];
			$typeCmd = $typeEqLogic . 'Cmd';
			if ($typeEqLogic == '' || !class_exists($typeEqLogic) || !class_exists($typeCmd)) {
				throw new Exception(__('Type incorrect (classe commande inexistante)', __FILE__) . secureXSS($typeCmd));
			}
		}
		if (!is_object($cmd)) {
			if (is_object($_USER_GLOBAL) && $_USER_GLOBAL->getProfils() != 'admin') {
				throw new Exception(__('Vous n\'êtes pas autorisé à effectuer cette action', __FILE__), -32001);
			}
			$cmd = new cmd();
		}
		utils::a2o($cmd, jeedom::fromHumanReadable($params));
		$cmd->save();
		$jsonrpc->makeSuccess(utils::o2a($cmd));
	}

	if ($jsonrpc->getMethod() == 'cmd::event') {
		$cmd = cmd::byId($params['id']);
		if (!is_object($cmd)) {
			throw new Exception('Commande introuvable : ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$cmd->hasRight($_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur cette commande', __FILE__), -32701);
		}
		if (!isset($params['datetime'])) {
			$params['datetime'] = null;
		}
		$cmd->event($params['value'], $params['datetime']);
		$jsonrpc->makeSuccess();
	}

	/*             * ************************Scénario*************************** */
	if ($jsonrpc->getMethod() == 'scenario::all') {
		$scenarios = array();
		foreach (scenario::all() as $scenario) {
			if (is_object($_USER_GLOBAL) && !$scenario->hasRight('r', $_USER_GLOBAL)) {
				continue;
			}
			$scenarios[] = $scenario;
		}
		$jsonrpc->makeSuccess(utils::o2a($scenarios));
	}

	if ($jsonrpc->getMethod() == 'scenario::byId') {
		$scenario = scenario::byId($params['id']);
		if (!is_object($scenario)) {
			throw new Exception(__('Scénario introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32703);
		}
		if (is_object($_USER_GLOBAL) && !$scenario->hasRight('r', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur ce scénario', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a($scenario));
	}

	if ($jsonrpc->getMethod() == 'scenario::changeState') {
		$scenario = scenario::byId($params['id']);
		if (!is_object($scenario)) {
			throw new Exception(__('Scénario introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$scenario->hasRight('w', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur ce scénario', __FILE__), -32701);
		}
		if ($params['state'] == 'stop') {
			$jsonrpc->makeSuccess($scenario->stop());
		}
		if ($params['state'] == 'run') {
			$jsonrpc->makeSuccess($scenario->launch('api', __('Scénario exécuté sur appel API', __FILE__)));
		}
		if ($params['state'] == 'enable') {
			$scenario->setIsActive(1);
			$jsonrpc->makeSuccess($scenario->save());
		}
		if ($params['state'] == 'disable') {
			$scenario->setIsActive(0);
			$jsonrpc->makeSuccess($scenario->save());
		}
		throw new Exception(__('Le paramètre "state" ne peut être vide et doit avoir pour valeur [run,stop,enable,disable]', __FILE__));
	}

	if ($jsonrpc->getMethod() == 'scenario::export') {
		$scenario = scenario::byId($params['id']);
		if (!is_object($scenario)) {
			throw new Exception(__('Scénario introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32702);
		}
		if (is_object($_USER_GLOBAL) && !$scenario->hasRight('w', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur ce scénario', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(array('humanName' => $scenario->getHumanName(), 'export' => $scenario->export('array')));
	}

	if ($jsonrpc->getMethod() == 'scenario::import') {
		unautorizedInDemo();
		if (isset($params['id'])) {
			$scenario = scenario::byId($params['id']);
			if (!is_object($scenario)) {
				throw new Exception(__('Scénario introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32702);
			}
		} else if (isset($params['humanName'])) {
			$scenario = scenario::byString($params['humanName']);
			if (!is_object($scenario)) {
				throw new Exception(__('Scénario introuvable :', __FILE__) . ' ' . secureXSS($params['id']), -32702);
			}
		} else {
			$scenario = new scenario();
			if (isset($params['import']['name'])) {
				$scenario->setName($params['import']['name']);
			}
			if (isset($params['import']['group'])) {
				$scenario->setName($params['import']['group']);
			}
		}
		if ($scenario->getName() == '') {
			$scenario->setName(config::genKey());
		}
		if (is_object($_USER_GLOBAL) && !$scenario->hasRight('w', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur ce scénario', __FILE__), -32701);
		}
		$scenario->setTrigger(array());
		$scenario->setSchedule(array());
		utils::a2o($scenario, $params['import']);
		$scenario->save();
		$scenario_element_list = array();
		if (isset($params['import']['elements'])) {
			foreach ($params['import']['elements'] as $element_ajax) {
				$scenario_element_list[] = scenarioElement::saveAjaxElement($element_ajax);
			}
			$scenario->setScenarioElement($scenario_element_list);
		}
		$scenario->save();
		$jsonrpc->makeSuccess(utils::o2a($scenario));
	}

	if ($jsonrpc->getMethod() == 'scenario::save') {
		unautorizedInDemo();
		if (isset($params['id'])) {
			$scenario = scenario::byId($params['id']);
		}
		if (!is_object($scenario)) {
			$scenario = new scenario();
		}
		if (is_object($_USER_GLOBAL) && !$scenario->hasRight('w', $_USER_GLOBAL)) {
			throw new Exception(__('Vous n\'avez pas les droits sur ce scénario', __FILE__), -32701);
		}
		utils::a2o($scenario, jeedom::fromHumanReadable($params));
		$scenario->save();
		$jsonrpc->makeSuccess(utils::o2a($scenario));
	}

	/*             * ************************Log*************************** */
	if ($jsonrpc->getMethod() == 'log::get') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(log::get($params['log'], $params['start'], $params['nbLine']));
	}

	if ($jsonrpc->getMethod() == 'log::getDelta') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(log::getDelta(
			$params['log'],
			$params['position'],
			$params['search'],
			$params['position'],
			$params['colored'],
			$params['numbered'],
			$params['numStart'],
			$params['max']
		));
	}

	if ($jsonrpc->getMethod() == 'log::getLastLine') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(log::getLastLine($params['log']));
	}

	if ($jsonrpc->getMethod() == 'log::add') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		if (!isset($params['logicalId'])) $params['logicalId'] = '';
		$jsonrpc->makeSuccess(log::add($params['log'], $params['type'], $params['message'], $params['logicalId']));
	}

	if ($jsonrpc->getMethod() == 'log::list') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		if (!isset($params['filtre'])) {
			$params['filtre'] = null;
		}
		$jsonrpc->makeSuccess(log::liste($params['filtre']));
	}

	if ($jsonrpc->getMethod() == 'log::empty') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(log::clear($params['log']));
	}

	if ($jsonrpc->getMethod() == 'log::remove') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		$jsonrpc->makeSuccess(log::remove($params['log']));
	}

	/*             * ************************Messages*************************** */
	if ($jsonrpc->getMethod() == 'message::removeAll') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		message::removeAll();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'message::removebyId') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$message = message::byId($params['messageId']);
		if (is_object($message)) {
			$message->remove();
			$jsonrpc->makeSuccess('ok');
		} else {
			throw new Exception(__('Impossible de trouver le message :', __FILE__) . ' ' . secureXSS($params['messageId']));
		}
	}

	if ($jsonrpc->getMethod() == 'message::all') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a(message::all()));
	}

	if ($jsonrpc->getMethod() == 'message::add') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		if (!isset($params['action'])) $params['action'] = '';
		if (!isset($params['logicalId'])) $params['logicalId'] = '';
		$jsonrpc->makeSuccess(message::add($params['type'], $params['message'], $params['action'], $params['logicalId']));
	}

	/*             * ************************Interact*************************** */
	if ($jsonrpc->getMethod() == 'interact::tryToReply') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		if (isset($params['reply_cmd'])) {
			$reply_cmd = cmd::byId($params['reply_cmd']);
			if (is_object($reply_cmd)) {
				$params['reply_cmd'] = $reply_cmd;
				$params['force_reply_cmd'] = 1;
			}
		}
		$jsonrpc->makeSuccess(interactQuery::tryToReply($params['query'], $params));
	}

	if ($jsonrpc->getMethod() == 'interactQuery::all') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a(interactQuery::all()));
	}

	/*             * ************************USB mapping*************************** */
	if ($jsonrpc->getMethod() == 'jeedom::getUsbMapping') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$name = (isset($params['name'])) ? $params['name'] : '';
		$gpio = (isset($params['gpio'])) ? $params['gpio'] : false;
		$jsonrpc->makeSuccess(jeedom::getUsbMapping($name, $gpio));
	}

	/*             * ************************Plugin*************************** */
	if ($jsonrpc->getMethod() == 'plugin::install') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		if (isset($params['plugin_id'])) {
			$update = update::byId($params['plugin_id']);
		}
		if (isset($params['logicalId'])) {
			$update = update::byLogicalId($params['logicalId']);
		}
		if (!isset($update) || !is_object($update)) {
			$update = new update();
		}
		utils::a2o($update, $params);
		$update->save();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'plugin::remove') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		if (isset($params['plugin_id'])) {
			$update = update::byId($params['plugin_id']);
		}
		if (isset($params['logicalId'])) {
			$update = update::byLogicalId($params['logicalId']);
		}
		if (!is_object($update)) {
			throw new Exception(__('Impossible de trouver l\'objet associé :', __FILE__) . ' ' . secureXSS($params['plugin_id']));
		}
		$update->remove();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'plugin::dependancyInfo') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess(array('state' => 'nok', 'log' => 'nok'));
		}
		$jsonrpc->makeSuccess($plugin->dependancy_info());
	}

	if ($jsonrpc->getMethod() == 'plugin::dependancyInstall') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess();
		}
		$plugin->dependancy_install();
		$jsonrpc->makeSuccess();
	}

	if ($jsonrpc->getMethod() == 'plugin::deamonInfo') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess(array('launchable_message' => '', 'launchable' => 'nok', 'state' => 'nok', 'log' => 'nok', 'auto' => 0));
		}
		$jsonrpc->makeSuccess($plugin->deamon_info());
	}

	if ($jsonrpc->getMethod() == 'plugin::deamonInfoAll') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$deamons_infos = [];
		foreach ((plugin::listPlugin()) as $plugin) {
			if ($plugin->getHasOwnDeamon() == 1) {
				$deamons_infos[$plugin->getId()] = $plugin->deamon_info();
			}
		}
		$jsonrpc->makeSuccess($deamons_infos);
	}

	if ($jsonrpc->getMethod() == 'plugin::deamonStart') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess();
		}
		if (!isset($params['debug'])) {
			$params['debug'] = false;
		}
		if (!isset($params['forceRestart'])) {
			$params['forceRestart'] = false;
		}
		$plugin->deamon_start($params['forceRestart']);
		$jsonrpc->makeSuccess();
	}

	if ($jsonrpc->getMethod() == 'plugin::deamonStop') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess();
		}
		$plugin->deamon_stop();
		$jsonrpc->makeSuccess();
	}

	if ($jsonrpc->getMethod() == 'plugin::deamonChangeAutoMode') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		$plugin = plugin::byId($params['plugin_id']);
		if (!is_object($plugin)) {
			$jsonrpc->makeSuccess();
		}
		$plugin->deamon_changeAutoMode($params['mode']);
		$jsonrpc->makeSuccess();
	}

	/*             * ************************Update*************************** */
	if ($jsonrpc->getMethod() == 'update::all') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user', 'restrict'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a(update::all()));
	}

	if ($jsonrpc->getMethod() == 'update::nbNeedUpdate') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(update::nbNeedUpdate());
	}

	if ($jsonrpc->getMethod() == 'update::update') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		jeedom::update('', 0);
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'update::checkUpdate') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		update::checkAllUpdate();
		$jsonrpc->makeSuccess('ok');
	}

	if ($jsonrpc->getMethod() == 'update::doUpdate') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		if (isset($params['plugin_id'])) {
			$update = update::byId($params['plugin_id']);
		}
		if (isset($params['logicalId'])) {
			$update = update::byLogicalId($params['logicalId']);
		}
		if (!is_object($update)) {
			throw new Exception(__('Impossible de trouver l\'objet', __FILE__));
		}
		$update->doUpdate();
		$jsonrpc->makeSuccess('ok');
	}

	/*             * ************************Network*************************** */

	if ($jsonrpc->getMethod() == 'network::restartDns') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		config::save('market::allowDNS', 1);
		network::dns_start();
		$jsonrpc->makeSuccess();
	}

	if ($jsonrpc->getMethod() == 'network::stopDns') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		unautorizedInDemo();
		config::save('market::allowDNS', 0);
		network::dns_stop();
		$jsonrpc->makeSuccess();
	}

	if ($jsonrpc->getMethod() == 'network::dnsRun') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin', 'user'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(network::dns_run());
	}

	/*             * ************************User*************************** */

	if ($jsonrpc->getMethod() == 'user::all') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$jsonrpc->makeSuccess(utils::o2a(user::all()));
	}

	if ($jsonrpc->getMethod() == 'user::save') {
		if (is_object($_USER_GLOBAL) && !in_array($_USER_GLOBAL->getProfils(), array('admin'))) {
			throw new Exception(__('Vous n\'avez pas les droits de faire cette action', __FILE__), -32701);
		}
		$user = user::byId($params['id']);
		if (!is_object($user)) {
			$user = new user();
		}
		utils::a2o($user, $params);
		$user->save();
		$jsonrpc->makeSuccess(utils::o2a($user));
	}

	/*             * ************************************************************************ */

	if (isset($params['plugin']) && $params['plugin'] != '' && $params['plugin'] != 'core') {
		log::add('api', 'info', __('Demande pour le plugin :', __FILE__) . ' ' . secureXSS($params['plugin']));
		try {
			include_file('core', $params['plugin'], 'api', $params['plugin']);
		} catch (\Exception $e) {
			if ($e->getCode() != 35486) {
				throw $e;
			}
		}
	}

	/*                                       Mobile API                                      */
	if ($jsonrpc->getMethod() == 'getJson') {
		log::add('api', 'debug', 'Demande du RDK to send with Json');
		if (!is_object($_USER_GLOBAL)) {
			throw new Exception(__('Utilisateur non défini', __FILE__), -32500);
		}
		$registerDevice = $_USER_GLOBAL->getOptions('registerDevice', array());
		if (!is_array($registerDevice)) {
			$registerDevice = array();
		}
		$rdk = (!isset($params['rdk']) || !isset($registerDevice[sha512($params['rdk'])])) ? config::genKey() : $params['rdk'];
		$registerDevice[sha512($rdk)] = array();
		$registerDevice[sha512($rdk)]['datetime'] = date('Y-m-d H:i:s');
		$registerDevice[sha512($rdk)]['ip'] = getClientIp();
		$registerDevice[sha512($rdk)]['session_id'] = session_id();
		$_USER_GLOBAL->setOptions('registerDevice', $registerDevice);
		$_USER_GLOBAL->save();
		log::add('api', 'debug', 'RDK :' . $rdk);
		log::add('api', 'debug', 'Demande du GetJson');
		$return = array();
		$idBox = jeedom::getHardwareKey();
		$return[$idBox]['apikeyUser'] = $_USER_GLOBAL->getHash();
		$return[$idBox]['configs'] = 'undefined';
		$return[$idBox]['appMobile'] = false;
		$return[$idBox]['externalIp'] = network::getNetworkAccess('external');
		$return[$idBox]['hardware'] = jeedom::getHardwareName();
		$return[$idBox]['hwkey'] = jeedom::getHardwareKey();
		$return[$idBox]['informations']['hardware'] = jeedom::getHardwareName();
		$return[$idBox]['informations']['language'] = config::byKey('language');
		$return[$idBox]['informations']['nbMessage'] = message::nbMessage();
		$return[$idBox]['informations']['nbUpdate'] = update::nbNeedUpdate();
		$return[$idBox]['informations']['uname'] = system::getDistrib() . ' ' . system::getOsVersion();
		$return[$idBox]['jeedom_version'] = jeedom::version();
		$return[$idBox]['localIp'] = network::getNetworkAccess('internal');
		$return[$idBox]['rdk'] = $rdk;
		$return[$idBox]['name'] = config::byKey('name');
		$jsonrpc->makeSuccess($return);
	}
	throw new Exception(__('Aucune méthode correspondante :', __FILE__) . ' ' . secureXSS($jsonrpc->getMethod()), -32500);
	/*         * *********Catch exeption*************** */
} catch (Exception $e) {
	$message = $e->getMessage();
	$jsonrpc = new jsonrpc(init('request'));
	$errorCode = (is_numeric($e->getCode())) ? -32000 - $e->getCode() : -32599;
	log::add('api', 'info', 'Error code ' . $errorCode . ' : ' . secureXSS($message));
	$jsonrpc->makeError($errorCode, $message);
}
