# Design
**Startseite → Design**

Auf dieser Seite können Sie die Anzeige Ihrer gesamten Hausautomation auf sehr feine Weise konfigurieren.
Es braucht Zeit, aber seine einzige Grenze ist Ihre Vorstellungskraft.

> **Tipp**
>
> Dank des Untermenüs ist es möglich, direkt zu einem Entwurf zu gelangen.

> **Wichtig**
>
> Alle Aktionen werden ausgeführt, indem Sie mit der rechten Maustaste auf diese Seite klicken. Achten Sie darauf, dass dies im Design gut funktioniert. Beim Erstellen müssen Sie dies in der Mitte der Seite tun (um sicherzugehen, dass Sie sich im Design befinden).

Im Menü (Rechtsklick) finden wir folgende Aktionen :

- **Entwürfe** : Zeigt die Liste Ihrer Designs an und ermöglicht Ihnen den Zugriff darauf.
- **Bearbeitung** : Wechseln Sie in den Bearbeitungsmodus.
- **Vollbild** : Ermöglicht die Verwendung der gesamten Webseite, wodurch das Jeedom-Menü von oben entfernt wird.
- **Grafik hinzufügen** : Fügen Sie eine Grafik hinzu.
- **Fügen Sie Text / HTML hinzu** : Ermöglicht das Hinzufügen von Text oder HTML / JavaScript-Code.
- **Szenario hinzufügen** : Fügen Sie ein Szenario hinzu.
- **Link hinzufügen**
    - **Auf dem Weg zu einer Aussicht** : Fügen Sie einer Ansicht einen Link hinzu.
    - **Auf dem Weg zu einem Design** : Fügen Sie einen Link zu einem anderen Design hinzu.
- **Ausrüstung hinzufügen** : Fügt Ausrüstung hinzu.
- **Bestellung hinzufügen** : Bestellung hinzufügen.
- **Bild / Kamera hinzufügen** : Ermöglicht das Hinzufügen eines Bildes oder eines Streams von einer Kamera.
- **Bereich hinzufügen** : Ermöglicht das Hinzufügen einer anklickbaren transparenten Zone, die während eines Klicks eine Reihe von Aktionen ausführen kann (abhängig vom Status eines anderen Befehls oder nicht).
- **Zusammenfassung hinzufügen** : Fügt Informationen aus einem Objekt oder einer allgemeinen Zusammenfassung hinzu.
- **Anzeige**
    - **Keiner** : Zeigt kein Raster an.
    - **10x10** : Zeigt ein 10 x 10-Raster an.
    - **15x15** : Zeigt ein Raster von 15 mal 15 an.
    - **20x20** : Zeigt ein 20 x 20-Raster an.
    - **Magnetisieren Sie die Elemente** : Fügt eine Magnetisierung zwischen den Elementen hinzu, um das Aufkleben zu erleichtern.
    - **Magnet auf dem Gitter** : Fügen Sie dem Raster eine Magnetisierung der Elemente hinzu (Aufmerksamkeit : Abhängig vom Zoom des Elements kann diese Funktionalität mehr oder weniger funktionieren).
    - **Hervorheben von Elementen ausblenden** : Hervorheben von Elementen ausblenden.
- **Design löschen** : Design entfernen.
- **Erstellen Sie ein Design** : Ermöglicht das Hinzufügen eines neuen Designs.
- **Doppeltes Design** : Dupliziert das aktuelle Design.
- **Konfigurieren Sie das Design** : Zugriff auf die Konfiguration des Designs.
- **Zu schützen** : Speichern Sie das Design (beachten Sie, dass bei bestimmten Aktionen auch automatische Sicherungen durchgeführt werden).

> **Wichtig**
>
> Die Konfiguration der Designelemente erfolgt durch Klicken.

## Designkonfiguration

Hier gefunden :

- **General**
    - **Nachname** : Der Name Ihres Designs.
    - **Position** : Die Position des Designs im Menü. Ermöglicht die Bestellung der Designs.
    - **Transparenter Hintergrund** : Macht den Hintergrund transparent. Achtung Wenn das Kontrollkästchen aktiviert ist, wird die Hintergrundfarbe nicht verwendet.
    - **Hintergrundfarbe** : Design Hintergrundfarbe.
    - **Zugangscode** : Zugriffscode für Ihr Design (falls leer, ist kein Code erforderlich).
    - **Symbol** : Ein Symbol dafür (erscheint im Designauswahlmenü).
    - **Bild**
        - **Senden** : Ermöglicht das Hinzufügen eines Hintergrundbilds zum Design.
        - **Bild löschen** : Bild löschen.
- **Größen**
    - **Größe (BxH)** : Ermöglicht das Festlegen der Größe Ihres Designs in Pixel.

## Allgemeine Konfiguration der Elemente

> **Notiz**
>
> Je nach Art des Elements können sich die Optionen ändern.

### Allgemeine Anzeigeeinstellungen

- **Tiefe** : Ermöglicht die Auswahl der Tiefenstufe
- **X-Position (%)** : Horizontale Koordinate des Elements.
- **Y-Position (%)** : Vertikale Koordinate des Elements.
- **Breite (px)** : Elementbreite in Pixel.
- **Höhe (px)** : Elementhöhe in Pixel.

### Supprimer

Gegenstand entfernen

### Dupliquer

Ermöglicht das Duplizieren des Elements

### Verrouiller

Ermöglicht das Sperren des Elements, sodass es nicht mehr beweglich oder in der Größe veränderbar ist.

## Graphique

### Spezifische Anzeigeeinstellungen

- **Zeit** : Hier können Sie den Anzeigezeitraum auswählen
- **Bildunterschrift anzeigen** : Zeigt die Legende an.
- **Browser anzeigen** : Zeigt den Browser an (zweite hellere Grafik unter der ersten).
- **Periodenauswahl anzeigen** : Zeigt den Periodenwähler oben links an.
- **Bildlaufleiste anzeigen** : Zeigt die Bildlaufleiste an.
- **Transparenter Hintergrund** : Macht den Hintergrund transparent.
- **Grenze** : Ermöglicht das Hinzufügen eines Rahmens. Achten Sie darauf, dass die Syntax HTML ist (seien Sie vorsichtig, Sie müssen beispielsweise die CSS-Syntax verwenden : festes 1px schwarz).

### Erweiterte Konfiguration

Hier können Sie die Befehle auswählen, die erfasst werden sollen.

## Text / html

### Spezifische Anzeigeeinstellungen

- **Symbol** : Symbol vor dem Designnamen.
- **Hintergrundfarbe** : Mit dieser Option können Sie die Hintergrundfarbe ändern oder transparent machen. Vergessen Sie nicht, &quot;Standard&quot; auf NEIN zu ändern.
- **Textfarbe** : Mit dieser Option können Sie die Farbe von Symbolen und Texten ändern (achten Sie darauf, die Standardeinstellung auf Nein zu setzen)..
- **Rund um die Winkel** : erlaubt das Abrunden der Winkel (vergessen Sie nicht,%, ex 50% zu setzen).
- **Grenze** : Wenn Sie einen Rahmen hinzufügen möchten, achten Sie darauf, dass die Syntax HTML ist (Sie müssen beispielsweise die CSS-Syntax verwenden : festes 1px schwarz).
- **Schriftgröße** : Mit dieser Option können Sie die Schriftgröße ändern (ab 50% müssen Sie das% -Zeichen eingeben).
- **Textausrichtung** : Mit dieser Option können Sie die Ausrichtung des Texts auswählen (links / rechts / zentriert)).
- **Fett gedruckt** : fetter Text.
- **Text** : Text im HTML-Code, der sich im Element befindet.

> **Wichtig**
>
> Wenn Sie HTML-Code (insbesondere Javascript) einfügen, überprüfen Sie diesen sorgfältig, da dies möglich ist, wenn ein Fehler vorliegt oder wenn eine Jeedom-Komponente überschrieben wird, das Design vollständig abstürzt und nur gelöscht werden muss direkt in die Datenbank.

## Szenario

*Keine spezifischen Anzeigeeinstellungen*

## Lien

### Spezifische Anzeigeeinstellungen

- **Nachname** : Name des Links (angezeigter Text).
- **Verknüpfung** : Link zum betreffenden Design oder zur betreffenden Ansicht.
- **Hintergrundfarbe** : Mit dieser Option können Sie die Hintergrundfarbe ändern oder transparent machen. Vergessen Sie nicht, &quot;Standard&quot; auf NEIN zu ändern.
- **Textfarbe** : Mit dieser Option können Sie die Farbe von Symbolen und Texten ändern (achten Sie darauf, die Standardeinstellung auf Nein zu setzen).
- **Runden Sie die Winkel ab (vergessen Sie nicht,%, ex 50%, anzugeben)** : Ermöglicht das Abrunden der Winkel. Vergessen Sie nicht, die% anzugeben.
- **Rand (Aufmerksamkeit CSS-Syntax, z : festes 1px schwarz)** : Ermöglicht das Hinzufügen eines Rahmens. Beachten Sie, dass die Syntax HTML ist.
- **Schriftgröße (ex 50%, Sie müssen das% -Zeichen setzen)** : Ermöglicht das Ändern der Schriftgröße.
- **Textausrichtung** : Mit dieser Option können Sie die Ausrichtung des Texts auswählen (links / rechts / zentriert)).
- **Fett gedruckt** : Fetter Text.

## Equipement

### Spezifische Anzeigeeinstellungen

- **Objektnamen anzeigen** : Aktivieren Sie diese Option, um den Namen des übergeordneten Objekts des Geräts anzuzeigen.
- **Name verstecken** : Überprüfen Sie, ob der Name des Geräts ausgeblendet ist.
- **Hintergrundfarbe** : Ermöglicht die Auswahl einer benutzerdefinierten Hintergrundfarbe oder die Anzeige des Geräts mit transparentem Hintergrund oder die Verwendung der Standardfarbe.
- **Textfarbe** : Hier können Sie eine benutzerdefinierte Hintergrundfarbe auswählen oder die Standardfarbe verwenden.
- **Gerundet** : Wert in Pixel der Rundung der Winkel der Gerätekachel.
- **Grenze** : CSS-Definition einer Gerätekachelgrenze. Ex : 1px festes Schwarz.
- **Opazität** : Deckkraft der Gerätekachel zwischen 0 und 1. Aufmerksamkeit : Es muss eine Hintergrundfarbe definiert werden.
- **Benutzerdefiniertes CSS** : CSS-Regeln für das Gerät.
- **Wenden Sie benutzerdefiniertes CSS auf an** : CSS-Auswahl, auf die benutzerdefiniertes CSS angewendet werden soll.

### Commandes

Die Liste der auf dem Gerät vorhandenen Befehle ermöglicht es Ihnen, für jeden Befehl Folgendes zu tun:
- Befehlsname ausblenden.
- Befehl ausblenden.
- Zeigen Sie die Bestellung mit einem transparenten Hintergrund an.

### Erweiterte Konfiguration

Zeigt das Fenster zur erweiterten Gerätekonfiguration an (siehe Dokumentation **Zusammenfassung der Hausautomation**).

## Commande

*Keine spezifischen Anzeigeeinstellungen*

### Erweiterte Konfiguration

Zeigt das Fenster zur erweiterten Gerätekonfiguration an (siehe Dokumentation **Zusammenfassung der Hausautomation**).

## Bild / Kamera

### Spezifische Anzeigeeinstellungen

- **Zum Anzeigen** : Definiert, was Sie anzeigen, Standbilder erstellen oder von einer Kamera streamen möchten.
- **Bild** : Senden Sie das betreffende Bild (wenn Sie ein Bild ausgewählt haben).
- **Kamera** : Zu zeigende Kamera (wenn Sie Kamera gewählt haben).

## Zone

### Spezifische Anzeigeeinstellungen

- **Art der Zone** : Hier wählen Sie die Art des Bereichs : Einfaches Makro, Binärmakro oder Widget beim Hover.

### Einzelne Makro

In diesem Modus führt ein Klick auf die Zone eine oder mehrere Aktionen aus. Hier müssen Sie nur die Liste der Aktionen angeben, die ausgeführt werden sollen, wenn Sie auf den Bereich klicken.

### Binäres Makro

In diesem Modus führt Jeedom je nach Status des von Ihnen angegebenen Befehls die Ein- oder Ausschaltaktion (en) aus. Ex : Wenn der Befehl 0 wert ist, führt Jeedom die Ein-Aktion (en) aus, andernfalls führt es die Aus-Aktion (en) aus

- **Binäre Informationen** : Befehl, der den Status zum Überprüfen angibt, um zu entscheiden, welche Aktion ausgeführt werden soll (Ein oder Aus)).

Sie müssen nur die Aktionen ausführen, die für das Ein und das Aus ausgeführt werden sollen.

### Hover-Widget

In diesem Modus wird beim Bewegen oder Klicken im Bereich Jeedom das betreffende Widget angezeigt.

- **Ausrüstung** : Widget, das beim Bewegen oder Klicken angezeigt wird.
- **Show auf Überführung** : Wenn diese Option aktiviert ist, wird das Widget beim Hover angezeigt.
- **Ansicht mit einem Klick** : Wenn diese Option aktiviert ist, wird das Widget beim Klicken angezeigt.
- **Position** : Hier können Sie auswählen, wo das Widget angezeigt werden soll (standardmäßig unten rechts)).

## Zusammenfassung

### Spezifische Anzeigeeinstellungen

- **Verknüpfung** : Ermöglicht die Angabe der anzuzeigenden Zusammenfassung (Allgemein für die globale Angabe andernfalls das Thema).
- **Hintergrundfarbe** : Mit dieser Option können Sie die Hintergrundfarbe ändern oder transparent machen. Vergessen Sie nicht, &quot;Standard&quot; auf NEIN zu ändern.
- **Textfarbe** : Mit dieser Option können Sie die Farbe von Symbolen und Texten ändern (achten Sie darauf, die Standardeinstellung auf Nein zu setzen).
- **Runden Sie die Winkel ab (vergessen Sie nicht,%, ex 50%, anzugeben)** : Ermöglicht das Abrunden der Winkel. Vergessen Sie nicht, die% anzugeben.
- **Rand (Aufmerksamkeit CSS-Syntax, z : festes 1px schwarz)** : Ermöglicht das Hinzufügen eines Rahmens. Beachten Sie, dass die Syntax HTML ist.
- **Schriftgröße (ex 50%, Sie müssen das% -Zeichen setzen)** : Ermöglicht das Ändern der Schriftgröße.
- **Fett gedruckt** : Fetter Text.

## FAQ

>**Ich kann mein Design nicht mehr bearbeiten**
>Wenn Sie ein Widget oder ein Bild eingefügt haben, das fast das gesamte Design einnimmt, müssen Sie außerhalb des Widgets oder Bildes klicken, um mit der rechten Maustaste auf das Menü zuzugreifen.

>**Löschen Sie ein Design, das nicht mehr funktioniert**
>Machen Sie im Administrationsteil und dann in OS / DB "select * from planHeader", stellen Sie die ID des betreffenden Designs wieder her und führen Sie "delete from planHeader where id" aus=#TODO#" und "aus plan löschen wo planHeader_id=#todo#" gut ersetzen #TODO# durch die zuvor gefundene Design-ID.
