# Synthèse
**Accueil → Synthèse**

La page *Synthèse* vous propose une synthèse visuelle et centralisée de vos objets et de leurs résumés.

![Synthèse](./images/synthesis_intro.gif)

Pour qu'elle prenne tout son sens, il faut sur chaque objet, configurer les résumés et une image de fond : [Voir documentation sur les résumés.](/fr_FR/concept/summary)

Vous pouvez la configurer comme page par défaut dans **Réglages → Préférences**, en desktop et/ou mobile.

## Affichage

Sur chaque objet, son image de fond et ses résumés sont affichés :

En fonction du type de résumé (clé), visible dans **Réglages → Système → Configuration / Résumés** :
- En haut à gauche : Le nom de l'objet.
- En haut à droite : La température (*temperature*) et l'humidité (*humidity*).
- Sous le titre : Alerte (*security*) et Mouvement (*motion*), colorés en vert ou en rouge suivant qu'il y a une ou des alertes / mouvement en cours.
- En bas : Tous les autres résumés de l'objet.

La configuration de l'affichage de l'objet se fait dans **Outils → Objets** :
- Son nom.
- Si il est visible. Vous pouvez toutefois conserver un Objet visible y compris sur le Dashboard, mais cocher *Masquer sur la synthèse*.
- Son image de fond.
- Si l'image de fond doit être utilisée uniquement sur la page Synthèse ou aussi en fond une fois sur l'objet.
- Les éléments de ses résumés, dans l'onglet *Résumé*.

> **Tip**
>
> L'ordre d'affichage des objets est celui du *résumé domotique*, que vous pouvez réordonner (Analyse → Résumé domotique).

> **Note**
>
> Si un objet n'a pas de résumé défini, un bouton s'affiche en haut à droite pour accéder à la configuration / résumés de l'objet.

## Fonctions

Pour chaque objet, vous pouvez cliquer :
- Sur le titre de l'objet pour afficher le Dashboard de cet objet avec ses objets enfants (également accessible par le menu *Accueil → Dashboard → Objet*).
- Sur l'image, pour ouvrir la page des équipements de cet objet seulement.
- Sur un élément de résumé pour afficher les éléments de cet objet, de ce type. Ceux-ci s'affichent dans une modale, sans changer de page, et permet de rapidement fermer un volet, allumer une lumière, etc. La taille de la modale s'adapte aux équipements qu'elle doit afficher, mais vous pouvez la déplacer. Même avec la modale de résumés ouverte, vous pouvez cliquer sur d'autres résumés.


> **Tip**
>
> Ctrl Clic ou Clic Centre sur l'objet ou un élément de résumé ouvre un autre onglet de votre navigateur.

Quand vous cliquez sur un objet à partir de la synthèse, le bouton à gauche de la barre de recherche est remplacé par un bouton permettant d'afficher un aperçu des pièces pour s'y rendre plus rapidement.

